#!/usr/bin/env -S julia --startup-file=no --history-file=no --project
mktempdir() do root
    mainre = r"Main\."
    run(`julia --trace-compile=$(joinpath(root, "instr.jl")) deps/precompile_script.jl`)
    open(joinpath((@__DIR__), "..", "src", "precompilings.jl"), "w") do stream
        println(stream, "#= generated by $(basename(@__FILE__)), do not update manually =#")
        println(stream, "module Precompilings")
        println(stream, "using ..BokehServer")
        println(stream, "using HTTP")
        println(stream, "using HTTP.Sockets")

        open(joinpath(root, "instr.jl")) do io
            for i ∈ eachline(io)
                if startswith(i, "precompile(Tuple{BokehServer") && !occursin(mainre, i)
                    println(stream, i)
                end
            end
        end
        println(stream, "end")
        println(stream, "using .Precompilings")
    end
end
